
#include <stdio.h>

main(argc, argv)
	char **argv;
{
	int c, c1, c2;
	int n;
	int addr = 0;
	char *x0 = "0x";

	x0 = "";

	while (*++argv && **argv == '-') {
		fprintf(stderr, "\
Usage: dis02 [file]\n");
		exit(2);
	}
	if (*argv && freopen(*argv, "r", stdin) == NULL) {
		perror(*argv);
		exit(1);
	}

	while ((c = getchar()) != EOF) {
		n = printf("L%04X: ", addr++);

#define byte x0, (addr+=1, (c1=getchar()))
#define word x0, (addr+=2, ((c1=getchar())<<8)|(c2=getchar()))

#define s n += printf
#define b n += printf
#define w n += printf

		c1 = c2 = -1;

		switch (c) {
		case 0x00: s("idl");
			break;
		case 0x30: b("br %s%02X", byte);
			break;
		case 0x31: b("bq %s%02X", byte);
			break;
		case 0x32: b("bz %s%02X", byte);
			break;
		case 0x33: b("bdf %s%02X", byte);
			break;
		case 0x34: b("b1 %s%02X", byte);
			break;
		case 0x35: b("b2 %s%02X", byte);
			break;
		case 0x36: b("b3 %s%02X", byte);
			break;
		case 0x37: b("b4 %s%02X", byte);
			break;
		case 0x38: s("skp");
			break;
		case 0x39: b("bnq %s%02X", byte);
			break;
		case 0x3A: b("bnz %s%02X", byte);
			break;
		case 0x3B: b("bnf %s%02X", byte);
			break;
		case 0x3C: b("bn1 %s%02X", byte);
			break;
		case 0x3D: b("bn2 %s%02X", byte);
			break;
		case 0x3E: b("bn3 %s%02X", byte);
			break;
		case 0x3F: b("bn4 %s%02X", byte);
			break;
		case 0x60: s("irx");
			break;
		case 0x68: s("???");
			break;
		case 0x70: s("ret");
			break;
		case 0x71: s("dis");
			break;
		case 0x72: s("ldxa");
			break;
		case 0x73: s("stxd");
			break;
		case 0x74: s("adc");
			break;
		case 0x75: s("sdb");
			break;
		case 0x76: s("shrC");
			break;
		case 0x77: s("smb");
			break;
		case 0x78: s("sav");
			break;
		case 0x79: s("mark");
			break;
		case 0x7A: s("req");
			break;
		case 0x7B: s("seq");
			break;
		case 0x7C: b("adci %s%02X", byte);
			break;
		case 0x7D: b("sdbi %s%02X", byte);
			break;
		case 0x7E: s("shlc");
			break;
		case 0x7F: b("smbi %s%02X", byte);
			break;
		case 0xC0: w("lbr %s%04X", word);
			break;
		case 0xC1: w("lbq %s%04X", word);
			break;
		case 0xC2: w("lbz %s%04X", word);
			break;
		case 0xC3: w("lbdf %s%04X", word);
			break;
		case 0xC4: s("nop");
			break;
		case 0xC5: s("lsnq");
			break;
		case 0xC6: s("lsnz");
			break;
		case 0xC7: s("lsnf");
			break;
		case 0xC8: s("lskp");
			break;
		case 0xC9: w("lbnq %s%04X", word);
			break;
		case 0xCA: w("lbnz %s%04X", word);
			break;
		case 0xCB: w("lbnf %s%04X", word);
			break;
		case 0xCC: s("lsie");
			break;
		case 0xCD: s("lsq");
			break;
		case 0xCE: s("lsz");
			break;
		case 0xCF: s("lsdf");
			break;
		case 0xF0: s("ldx");
			break;
		case 0xF1: s("or");
			break;
		case 0xF2: s("and");
			break;
		case 0xF3: s("xor");
			break;
		case 0xF4: s("add");
			break;
		case 0xF5: s("sd");
			break;
		case 0xF6: s("shr");
			break;
		case 0xF7: s("sm");
			break;
		case 0xF8: b("ldi %s%02X", byte);
			break;
		case 0xF9: b("ori %s%02X", byte);
			break;
		case 0xFA: b("ani %s%02X", byte);
			break;
		case 0xFB: b("xri %s%02X", byte);
			break;
		case 0xFC: b("adi %s%02X", byte);
			break;
		case 0xFD: b("sdi %s%02X", byte);
			break;
		case 0xFE: s("shl");
			break;
		case 0xFF: b("smi %s%02X", byte);
			break;

	default:
			switch (c >> 4) {

			case 0x0: s("ldn R%X", c & 0xF);
				break;
			case 0x1: s("inc R%X", c & 0xF);
				break;
			case 0x2: s("dec R%X", c & 0xF);
				break;
			case 0x4: s("lda R%X", c & 0xF);
				break;
			case 0x5: s("str R%X", c & 0xF);
				break;
			case 0x6: s("%s D%X", (c & 8) ? "inp" : "out", c & 7);
				break;
			case 0x8: s("glo R%X", c & 0xF);
				break;
			case 0x9: s("ghi R%X", c & 0xF);
				break;
			case 0xA: s("plo R%X", c & 0xF);
				break;
			case 0xB: s("phi R%X", c & 0xF);
				break;
			case 0xD: s("sep R%X", c & 0xF);
				break;
			case 0xE: s("sex R%X", c & 0xF);
				break;
			}
		}
		do {
			putchar(' ');
		} while (++n < 20);

		printf("# %s%02X", x0, c);
		if (c1 != -1)
			printf(" %s%02X", x0, c1);
		if (c2 != -1)
			printf(" %s%02X", x0, c2);

		printf(" \n");
	}
	exit(1);
}

